unit Debug;

{*******************************************************}
{                                                       }
{       Delphi Debug Library                            }
{                                                       }
{       2001..2004, 2007 YT                             }
{                                                       }
{*******************************************************}

{$WARN SYMBOL_PLATFORM OFF}

interface

procedure AssignDebug(var F: Text);

implementation

uses
	Windows;

function DebugOpen(var T: Text): Integer;
begin
	Result := 0;
end;

function DebugInOut(var T: Text): Integer;
var
	I, S, L: Cardinal;
	C: Char;
begin
	{This function be called by System.Write}
	L := 0;
	for I := Low(TTextBuf) to TTextRec(T).BufPos - 1 do
	begin
		if TTextRec(T).Buffer[I] = #13 then
		begin
			S := L;
			L := I + 1;
			if (I < TTextRec(T).BufPos - 1) and (TTextRec(T).Buffer[I + 1] = #10) then
			begin
				Inc(L);
			end;
			C := TTextRec(T).Buffer[L];
			TTextRec(T).Buffer[L] := #0;
			OutputDebugString(TTextRec(T).Buffer + S);
			TTextRec(T).Buffer[L] := C;
		end;
	end;
	if TTextRec(T).BufPos >= L + 80 then
	begin
		S := L;
		L := TTextRec(T).BufEnd;
		C := TTextRec(T).Buffer[L];
		TTextRec(T).Buffer[L] := #0;
		OutputDebugString(TTextRec(T).Buffer + S);
		TTextRec(T).Buffer[L] := C;
	end;
	if L > 0 then
	begin
		TTextRec(T).BufPos := TTextRec(T).BufPos - L;
		Move(
			TTextRec(T).Buffer[L],
			TTextRec(T).Buffer[0],
			TTextRec(T).BufPos);
	end;
	TTextRec(T).BufEnd := TTextRec(T).BufPos;
	Result := 0
end;

function DebugFlush(var T: Text): Integer;
begin
	{This function be called by System.WriteLn or System.Flush}
  DebugInOut(T);
	if TTextRec(T).BufPos > 0 then
	begin
		TTextRec(T).Buffer[TTextRec(T).BufPos] := #0;
		OutputDebugString(TTextRec(T).Buffer);
	end;
	TTextRec(T).BufPos := 0;
	TTextRec(T).BufEnd := 0;
	Result := 0;
end;

function DebugClose(var T: Text): Integer;
begin
  Result := DebugFlush(T)
end;

procedure AssignDebug(var F: Text);
begin
	TTextRec(F).Handle := 0;
	TTextRec(F).Mode := fmClosed;
	{TTextRec(F).Flags := 0;}
	TTextRec(F).BufSize := SizeOf(TTextRec(F).Buffer) - 1; {for #0}
	TTextRec(F).BufPos := 0;
	TTextRec(F).BufEnd := 0;
	TTextRec(F).BufPtr := TTextRec(F).Buffer;
	TTextRec(F).OpenFunc := @DebugOpen;
	TTextRec(F).InOutFunc := @DebugInOut;
	TTextRec(F).FlushFunc := @DebugFlush;
	TTextRec(F).CloseFunc := @DebugClose;
	{TTextRec(F).UserData := ...}
	TTextRec(F).Name[0] := #0;
	TTextRec(F).Buffer[High(TTextBuf)] := #0;
end;

initialization

	if not IsConsole then
		AssignDebug(Output);

end.

