unit ShlTips;

{*******************************************************}
{                                                       }
{       Delphi Run-Time Library                         }
{       Win32 Shell API Tips Collection                 }
{                                                       }
{       1998..2006 YT                                   }
{                                                       }
{*******************************************************}

interface

uses
	Windows, Messages, SysUtils, SysConst, ShellApi, ShlObj, ActiveX, UrlMon,
	SysUtilsW, WinTips;

type
	TShellLink = object
	private
		FShellLink: IShellLinkW;
{$HINTS OFF}
		Dummy: Pointer; {object̃TCYWX^Ɏ܂ƎXR[hoOc}
{$HINTS ON}
		function GetArguments: WideString;
		procedure SetArguments(const Value: WideString);
		function GetDescription: WideString;
		procedure SetDescription(const Value: WideString);
		function GetPath: WideString;
		procedure SetPath(const Value: WideString);
		function GetWorkingDirectory: WideString;
		procedure SetWorkingDirectory(const Value: WideString);
    function GetItemIDList: PItemIDList;
	public
		constructor Initialize;
		destructor Finalize;
		function Resolve(Wnd: HWND): Boolean;
		procedure LoadFromFile(const FileName: WideString);
		procedure SaveToFile(const FileName: WideString);
		property Arguments: WideString read GetArguments write SetArguments;
		property Description: WideString read GetDescription write SetDescription;
		property Path: WideString read GetPath write SetPath;
		property WorkingDirectory: WideString read GetWorkingDirectory write SetWorkingDirectory;
		property ItemIDList: PItemIDList read GetItemIDList;
		property ShellLink: IShellLinkW read FShellLink;
	end;

type
	TCustomDataObject = class(TInterfacedObject)
	protected
		function GetData(const formatetcIn: TFormatEtc; out medium: TStgMedium): HResult; stdcall;
		function GetDataHere(const formatetc: TFormatEtc; out medium: TStgMedium): HResult; stdcall;
		function QueryGetData(const formatetc: TFormatEtc): HResult; stdcall;
		function GetCanonicalFormatEtc(const formatetc: TFormatEtc; out formatetcOut: TFormatEtc): HResult; stdcall;
		function SetData(const formatetc: TFormatEtc; var medium: TStgMedium; fRelease: BOOL): HResult; stdcall;
		function EnumFormatEtc(dwDirection: Longint; out enumFormatEtc: IEnumFormatEtc): HResult; stdcall;
		function DAdvise(const formatetc: TFormatEtc; advf: Longint; const advSink: IAdviseSink; out dwConnection: Longint): HResult; stdcall;
		function DUnadvise(dwConnection: Longint): HResult; stdcall;
		function EnumDAdvise(out enumAdvise: IEnumStatData): HResult; stdcall;
	end;

	PFormatEtcArray = ^TFormatEtcArray;
	TFormatEtcArray = array[0..32767] of FORMATETC;

	PStgMediumArray = ^TStgMediumArray;
	TStgMediumArray = array[0..32767] of STGMEDIUM;

	TDataObject = class(TCustomDataObject, IDataObject)
	private
		FFormats: PFormatEtcArray;
		FMediums: PStgMediumArray;
		FCount: Integer;
		function CompareFormat(const F1, F2: TFormatEtc): Boolean;
	protected
		function GetData(const formatetcIn: TFormatEtc; out medium: TStgMedium): HResult; stdcall;
		function GetDataHere(const formatetc: TFormatEtc; out medium: TStgMedium): HResult; stdcall;
		function QueryGetData(const formatetc: TFormatEtc): HResult; stdcall;
		function SetData(const formatetc: TFormatEtc; var medium: TStgMedium; fRelease: BOOL): HResult; stdcall;
		function EnumFormatEtc(dwDirection: Longint; out enumFormatEtc: IEnumFormatEtc): HResult; stdcall;
		function GetCanonicalFormatEtc(const formatetc: TFormatEtc; out formatetcOut: TFormatEtc): HResult; stdcall;
	public
		destructor Destroy; override;
	end;

(*
	TEnumFormatETC = class(TInterfacedObject, IEnumFormatETC)
	private
		FDataObject: TDataObject;
		FIndex: Cardinal;
	protected
		function Next(celt: Longint; out elt; pceltFetched: PLongint): HResult; stdcall;
		function Skip(celt: Longint): HResult; stdcall;
		function Reset: HResult; stdcall;
		function Clone(out Enum: IEnumFormatEtc): HResult; stdcall;
	public
		constructor Create(DataObject: TDataObject);
	end;
*)

function CreateFileListDataObject(const Dir: WideString;
	const Files: array of WideString; Effect: DWORD = 0; IncludeText: Boolean = False): IDataObject;

function CreateContextMenu(Wnd: HWND; const Dir: WideString;
				const Files: array of WideString): IContextMenu; overload;
function CreateContextMenu(Wnd: HWND; const FileName: WideString): IContextMenu; overload;

function KeysToDropEffect(KeyState: DWORD): DWORD;

//ItemIDList
function GetNextItemID(ItemIDList: PItemIDList): PItemIDList;
function GetItemIDListSize(ItemIDList: PItemIDList): Integer;
function AllocateItemIDList(Size: Integer): PItemIDList;
function CopyItemID(ID: PItemIDList): PItemIDList;
function CopyItemIDList(ItemIDList: PItemIDList): PItemIDList;
function ConcatItemIDLists(IDList1, IDList2: PItemIDList): PItemIDList;
function IsFolder(const ShellFolder: IShellFolder; ItemIDList: PItemIDList): Boolean;
function GetFullyQualItemIDList(const ShellFolder: IShellFolder; ItemIDList: PItemIDList): PItemIDList;
function CompareItemID(const ShellFolder: IShellFolder; ItemID1, ItemID2: PItemIDList): Integer;
function StrRetToWideString(ItemIDList: PItemIDList; const R: STRRET): WideString;
function GetDisplayName(Folder: IShellFolder; Item: PItemIDList; Flags: DWORD): WideString;
procedure StripLastItemID(ItemIDList: PItemIDList); {[ItemID폜}
function GetLastItemID(ItemIDList: PItemIDList): PItemIDList; {[ItemIDw}

{Dir}
function SpecialFolderPath(Wnd: HWND; ID: Integer): WideString;

//ACR
function GetShellIcon(ItemIDList: PItemIDList; Large, Open: Boolean): HICON; overload;
function GetShellIcon(const Path: WideString; Large, Open: Boolean): HICON; overload;
function GetShellImageList: THandle;
function GetShellImageIndex(const Path: WideString; Large, Open: Boolean): Integer; overload;

//VFt@C
function ShowPropertySheet(Wnd: HWND; const FileName: TFileName): Boolean; overload;
function ShowPropertySheet(Wnd: HWND; const FileName: WideString): Boolean; overload;
function ShowPropertySheet(Wnd: HWND; ItemIDList: PItemIDList): Boolean; overload;

function DoubleNullTerminatedFileNameList(const Dir: WideString;
				const Files: array of WideString): WideString;

procedure ShellDeleteFiles(Wnd: HWND; const BasePath: WideString; const Files: array of WideString; Flags: FILEOP_FLAGS);
function ShellCopyOrMoveOrRenameFile(Wnd: HWND; const FileName, ToFileName: WideString; Func: UINT): Boolean;

{COM}

function CreateComObject(const ClassID: TGUID): IUnknown;

implementation

function CreateFileListDataObject(const Dir: WideString;
	const Files: array of WideString; Effect: DWORD; IncludeText: Boolean): IDataObject;
var
	P: Pointer;
	F: FORMATETC;
	M: STGMEDIUM;
	T, Path: WideString;
	I: Integer;
	{Shell IDList Array}
	Folder, Desktop: IShellFolder;
	ItemIDList: PItemIDList;
	Eaten, Attribs: ULONG;
	ItemIDLists: array of PItemIDList;
begin
	{Shell IDList Array}

	SHGetDesktopFolder(Desktop);

	if FAILED(Desktop.ParseDisplayName(0, nil,
					PWideChar(Dir), Eaten, ItemIDList, Attribs)) then
		raise EInOutError.Create(SFileNotFound);

	Desktop.BindToObject(ItemIDList, nil, IID_ISHELLFOLDER, Folder);

	CoTaskMemFree(ItemIDList);

	SetLength(ItemIDLists, Length(Files));

	for I := Low(Files) to High(Files) do
	begin
		if FAILED(Folder.ParseDisplayName(0, nil,
						PWideChar(Files[I]), Eaten, ItemIDList, Attribs)) then
			raise EInOutError.Create(SFileNotFound);

		ItemIDLists[I - Low(Files) + Low(ItemIDLists)] := ItemIDList;
	end;

	Folder.GetUIObjectOf(0, Length(ItemIDLists), ItemIDLists[0], IDataObject, nil, Result);

	for I := Low(ItemIDLists) to High(ItemIDLists) do
		CoTaskMemFree(ItemIDLists[I]);

	{}

	F.ptd      := nil;
	F.dwAspect := DVASPECT_CONTENT;
	F.lindex   := -1;
	F.tymed    := TYMED_HGLOBAL;

	M.tymed := TYMED_HGLOBAL;
	M.unkForRelease := nil;

	{Preferred DropEffect}

	if Effect <> 0 then
	begin
		F.cfFormat := RegisterClipboardFormatW(CFSTR_PREFERREDDROPEFFECT);

		M.hGlobal := GlobalAlloc(GMEM_MOVEABLE, SizeOf(DWORD));
		P := GlobalLock(M.hGlobal);
		DWORD(P^) := Effect;
		GlobalUnlock(M.hGlobal);

		Result.SetData(F, M, True);
	end;

	{Text}

	if IncludeText then
	begin
		Path := IncludeTrailingPathDelimiter(Dir);
		T := '';
		for I := Low(Files) to High(Files) do
			T := T + Path + Files[I] + #9;

		T[Length(T)] := #0;

		F.cfFormat := CF_UNICODETEXT;

		M.hGlobal := GlobalAlloc(GMEM_MOVEABLE, Length(T) * SizeOf(WideChar));
		P := GlobalLock(M.hGlobal);
		Move(PWideChar(T)^, P^, Length(T) * SizeOf(WideChar));
		GlobalUnlock(M.hGlobal);

		Result.SetData(F, M, True);
	end
end;

function CreateContextMenu(Wnd: HWND; const Dir: WideString;
				const Files: array of WideString): IContextMenu; overload;
var
	DesktopFolder, Folder: IShellFolder;
	I, J: Integer;
	ItemIDList: PItemIDList;
	ItemIDLists: array of PItemIDList;
	E, A: DWORD;
begin
	Result := nil;
	SHGetDesktopFolder(DesktopFolder);
	Folder := DesktopFolder;

	{eփoCh}
	if Dir <> '' then
	begin
		DesktopFolder.ParseDisplayName(Wnd, nil, PWideChar(Dir), E, ItemIDList, A);
		DesktopFolder.BindToObject(ItemIDList, nil, IShellFolder, Folder);
		CoTaskMemFree(ItemIDList);
		if Folder = nil then Exit;
	end;

	{ItemIDList}
	SetLength(ItemIDLists, Length(Files));
	for I := Low(ItemIDLists) to High(ItemIDLists) do
		if FAILED(Folder.ParseDisplayName(Wnd, nil, PWideChar(Files[I]), E, ItemIDLists[I], A)) then
		begin
			for J := I - 1 downto 0 do CoTaskMemFree(ItemIDLists[J]);
			Exit;
		end;

	Folder.GetUIObjectOf(Wnd, Length(ItemIDLists), ItemIDLists[0],
					IContextMenu, nil, Result);

	for I := Low(ItemIDLists) to High(ItemIDLists) do
		CoTaskMemFree(ItemIDLists[I]);
end;

function CreateContextMenu(Wnd: HWND; const FileName: WideString): IContextMenu; overload;
var
	F: array[0..0] of WideString;
begin
	F[0] := ExtractFileName(FileName);
	Result := CreateContextMenu(Wnd, ExtractFileDir(FileName), F)
end;

function KeysToDropEffect(KeyState: DWORD): DWORD;
begin
	if KeyState and (MK_CONTROL or MK_SHIFT) = (MK_CONTROL or MK_SHIFT) then
		Result := DROPEFFECT_LINK
	else if KeyState and MK_CONTROL <> 0 then
		Result := DROPEFFECT_COPY
	else
		Result := DROPEFFECT_MOVE;
end;

function GetNextItemID(ItemIDList: PItemIDList): PItemIDList;
begin
	if ItemIDList^.mkid.cb = 0 then
		Result := nil
	else
	begin
		Result := ItemIDList;
		Inc(PByte(Result), ItemIDList^.mkid.cb);
	end;
end;

function GetLastItemID(ItemIDList: PItemIDList): PItemIDList;
begin
	if ItemIDList = nil then
		Result := nil
	else
	begin
		Result := ItemIDList;
		while ItemIDList.mkid.cb <> 0 do
		begin
			Result := ItemIDList;
			ItemIDList := GetNextItemID(ItemIDList);
		end;
	end
end;

function GetItemIDListSize(ItemIDList: PItemIDList): Integer;
begin
	if ItemIDList = nil then
	begin
		Result := 0;
		Exit;
	end;

	Result := SizeOf(ItemIDList^.mkid.cb);
	while ItemIDList^.mkid.cb <> 0 do
	begin
		Inc(Result, ItemIDList^.mkid.cb);
		ItemIDList := GetNextItemID(ItemIDList);
	end;
end;

function AllocateItemIDList(Size: Integer): PItemIDList;
begin
	Result := CoTaskMemAlloc(Size);
	if Result = nil then OutOfMemoryError;
	FillChar(Result^, Size, 0);
end;

function CopyItemID(ID: PItemIDList): PItemIDList;
var
	Size: Cardinal;
begin
	Size := ID^.mkid.cb;

	Result := AllocateItemIDList(Size + SizeOf(Word));

	Move(ID^, Result^, Size);
	PWord(Cardinal(Result) + Size)^ := 0;
end;

function CopyItemIDList(ItemIDList: PItemIDList): PItemIDList;
var
	Size: Integer;
begin
	if ItemIDList = nil then
		Result := nil
	else
	begin
		Size := GetItemIDListSize(ItemIDList);
		Result := AllocateItemIDList(Size);
		Move(ItemIDList^, Result^, Size);
	end	
end;

function ConcatItemIDLists(IDList1, IDList2: PItemIDList): PItemIDList;
var
	Size1, Size2: Integer;
begin
	if IDList1 <> nil then
		Size1 := GetItemIDListSize(IDList1) - SizeOf(IDList1^.mkid.cb)
	else
		Size1 := 0;

	Size2 := GetItemIDListSize(IDList2);

	Result := AllocateItemIDList(Size1 + Size2);

	if IDList1 <> nil then
		Move(IDList1^, Result^, Size1);

	Move(IDList2^, PItemIDList(Integer(Result) + Size1)^, Size2);
end;

procedure StripLastItemID(ItemIDList: PItemIDList);
var
	MarkerID: PItemIDList;
begin
	if ItemIDList = nil then
		Exit;

	MarkerID := ItemIDList;
	while ItemIDList.mkid.cb <> 0 do
	begin
		MarkerID := ItemIDList;
		ItemIDList := GetNextItemID(ItemIDList);
	end;
	MarkerID.mkid.cb := 0;
end;

function IsFolder(const ShellFolder: IShellFolder; ItemIDList: PItemIDList): Boolean;
var
	Flags: UINT;
begin
	Flags := SFGAO_FOLDER;
	ShellFolder.GetAttributesOf(1, ItemIDList, Flags);
	Result := SFGAO_FOLDER and Flags <> 0;
end;

function GetFullyQualItemIDList(const ShellFolder: IShellFolder; ItemIDList: PItemIDList): PItemIDList;
var
 szBuff: string;
 W: WideString;
 DeskTop: IShellFolder;
 ulEaten, ulAttribs: ULONG;
 hr: HRESULT;
begin
	//ItemIDList wĂpXszBuffɓ
	szBuff := GetDisplayName(ShellFolder, ItemIDList, SHGDN_FORPARSING);

	hr := SHGetDesktopFolder(DeskTop);
	if FAILED(hr) then
	begin
		Result := nil;
		Exit;
	end;

	W := szBuff;
	hr := DeskTop.ParseDisplayName(0, nil, PWideChar(W), ulEaten, Result, ulAttribs);
	if FAILED(hr) then
		Result := nil;
end;

function CompareItemID(const ShellFolder: IShellFolder;
				ItemID1, ItemID2: PItemIDList): Integer;
begin
	Result := $FFFF and ShellFolder.CompareIDs(0, ItemID1, ItemID2);
end;

function StrRetToWideString(ItemIDList: PItemIDList; const R: STRRET): WideString;
begin
	case R.uType of
	STRRET_CSTR:
		Result := R.cStr;
	STRRET_OFFSET:
		Result := PChar(ItemIDList) + R.uOffset;
	STRRET_WSTR:
		if Assigned(R.pOleStr) then
			Result := R.pOleStr
		else
			Result := '';
	end;
end;

function GetDisplayName(Folder: IShellFolder; Item: PItemIDList; Flags: DWORD): WideString;
var
	StrRet: TStrRet;
begin
	FillChar(StrRet, SizeOf(StrRet), 0);
	if Folder.GetDisplayNameOf(Item, Flags, StrRet) = NOERROR then
		Result := StrRetToWideString(Item, StrRet);
end;

function SpecialFolderPath(Wnd: HWND; ID: Integer): WideString;
var
	P: PItemIDList;
begin
	SHGetSpecialFolderLocation(Wnd, ID, P);
	SetLength(Result, MAX_PATH);
	SHGetPathFromIDListW(P, PWideChar(Result));
	Result := IncludeTrailingPathDelimiter(PWideChar(Result)); {#0 ȍ~؂̂}
	CoTaskMemFree(P);
end;

const
	OpenOption: Array[Boolean] of Integer = (0, SHGFI_OPENICON);
	LargeOption: Array[Boolean] of Integer = (SHGFI_SMALLICON, SHGFI_LARGEICON);

function GetShellIcon(ItemIDList: PItemIDList; Large, Open: Boolean): HICON; overload;
var
	FileInfo: TSHFileInfoW;
	Flags: Integer;
begin
	Flags := SHGFI_PIDL or SHGFI_SYSICONINDEX or SHGFI_ICON or OpenOption[Open] or LargeOption[Large];
	SHGetFileInfoW(Pointer(ItemIDList), 0, FileInfo, SizeOf(FileInfo), Flags);
	Result := FileInfo.hIcon;
end;

function GetShellIcon(const Path: WideString; Large, Open: Boolean): HICON; overload;
var
	FileInfo: TSHFileInfoW;
	Flags: Integer;
begin
	Flags := SHGFI_SYSICONINDEX or SHGFI_ICON or OpenOption[Open] or LargeOption[Large];
	SHGetFileInfoW(Pointer(Path), 0, FileInfo, SizeOf(FileInfo), Flags);
	Result := FileInfo.hIcon;
end;

function GetShellImageList: THandle;
var
	Drive: WideString;
	FileInfo: TSHFileInfoW;
begin
	Drive := IncludeTrailingPathDelimiter(SystemDrive);
	Result := SHGetFileInfoW(Pointer(Drive), 0,
		FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
end;

function GetShellImageIndex(const Path: WideString; Large, Open: Boolean): Integer; overload;
var
	FileInfo: TSHFileInfoW;
	Flags: Integer;
begin
	Flags := SHGFI_SYSICONINDEX or OpenOption[Open] or LargeOption[Large];
	SHGetFileInfoW(Pointer(Path), 0, FileInfo, SizeOf(FileInfo), Flags);
	Result := FileInfo.iIcon;
end;

function ShowPropertySheet(Wnd: HWND; const FileName: TFileName): Boolean;
var
	ShellExecuteInfo: TShellExecuteInfo;
begin
	FillChar(ShellExecuteInfo, SizeOf(TShellExecuteInfo), 0);

	ShellExecuteInfo.cbSize := SizeOf(TShellExecuteInfo);
	ShellExecuteInfo.fmask  := SEE_MASK_INVOKEIDLIST;
	ShellExecuteInfo.WND    := Wnd;
	ShellExecuteInfo.lpVerb := 'properties';
	ShellExecuteInfo.lpFile := PChar(FileName);
	ShellExecuteInfo.nShow    := SW_SHOW;

	Result := ShellExecuteEx(@ShellExecuteInfo);
end;

function ShowPropertySheet(Wnd: HWND; const FileName: WideString): Boolean;
var
	ShellExecuteInfo: TShellExecuteInfoW;
begin
	FillChar(ShellExecuteInfo, SizeOf(ShellExecuteInfo), 0);

	ShellExecuteInfo.cbSize := SizeOf(ShellExecuteInfo);
	ShellExecuteInfo.fmask  := SEE_MASK_INVOKEIDLIST;
	ShellExecuteInfo.WND    := Wnd;
	ShellExecuteInfo.lpVerb := 'properties';
	ShellExecuteInfo.lpFile := PWideChar(FileName);
	ShellExecuteInfo.nShow    := SW_SHOW;

	Result := ShellExecuteExW(@ShellExecuteInfo);
end;

function ShowPropertySheet(Wnd: HWND; ItemIDList: PItemIDList): Boolean;
var
	ShellExecuteInfo: TShellExecuteInfoW;
begin
	FillChar(ShellExecuteInfo, SizeOf(ShellExecuteInfo), 0);

	ShellExecuteInfo.cbSize   := SizeOf(ShellExecuteInfo);
	ShellExecuteInfo.fmask    := SEE_MASK_INVOKEIDLIST or SEE_MASK_IDLIST;
	ShellExecuteInfo.WND      := Wnd;
	ShellExecuteInfo.lpVerb   := 'properties';
	ShellExecuteInfo.lpIDList := ItemIDList;
	ShellExecuteInfo.nShow    := SW_SHOW;

	Result := ShellExecuteExW(@ShellExecuteInfo);
end;

function DoubleNullTerminatedFileNameList(const Dir: WideString;
				const Files: array of WideString): WideString;
var
	Path: String;
	I: Integer;
begin
	if Dir <> '' then
		Path := IncludeTrailingPathDelimiter(Dir)
	else
		Path := '';

	Result := '';
	for I := Low(Files) to High(Files) do
	begin
		if Pos('\', Files[I]) > 0 then
			Result := Result + Files[I] + #0
		else
			Result := Result + Path + Files[I] + #0;
	end;

	Result := Result + #0;
end;

procedure ShellDeleteFiles(Wnd: HWND; const BasePath: WideString;
				const Files: array of WideString; Flags: FILEOP_FLAGS);
var
	Op: SHFILEOPSTRUCTW;
	From: WideString;
begin
	From := DoubleNullTerminatedFileNameList(BasePath, Files);

	FillChar(Op, SizeOf(Op), 0);
	Op.Wnd    := Wnd;
	Op.wFunc  := FO_DELETE;
	Op.pFrom  := PWideChar(From);
	Op.fFlags := Flags; //FOF_ALLOWUNDO or FOF_SILENT or FOF_NOCONFIRMATION;

	SHFileOperationW(OP);
end;

function ShellCopyOrMoveOrRenameFile(WND: HWND;
				const FileName, ToFileName: WideString; Func: UINT): Boolean;
var
	Op: SHFILEOPSTRUCTW;
	Fr2, To2: WideString;
begin
	Fr2 := FileName + #0;
	To2 := ToFileName + #0;

	FillChar(Op, SizeOf(Op), 0);
	Op.Wnd    := Wnd;
	Op.wFunc  := Func;
	Op.pFrom  := PWideChar(Fr2);
	Op.pTo    := PWideChar(To2);
	Op.fFlags := FOF_SILENT or FOF_NOCONFIRMATION;

	Result := SHFileOperationW(Op) = 0;
end;

function CreateComObject(const ClassID: TGUID): IUnknown;
var
	HR: HRESULT;
	E: EOSError;
begin
	HR := CoCreateInstance(ClassID, nil, CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER, IUnknown, Result);
	if FAILED(HR) then
	begin
		E := EOSError.Create(SysErrorMessage(HR));
		E.ErrorCode := HR;
		raise E;
	end;
end;

{ TShellLink }

destructor TShellLink.Finalize;
begin
  FShellLink := nil
end;

function TShellLink.GetArguments: WideString;
var
	Arg: Array[0..MAX_PATH] of WideChar;
begin
	FShellLink.GetArguments(Arg, MAX_PATH);
	Result := Arg;
end;

function TShellLink.GetDescription: WideString;
const
	MAX_LENGTH = 1024;
var
	Des: Array[0..MAX_LENGTH] of WideChar;
begin
	FShellLink.GetDescription(Des, MAX_LENGTH);
	Result:= Des;
end;

function TShellLink.GetItemIDList: PItemIDList;
begin
	if FAILED(FShellLink.GetIDList(Result)) then
		RaiseLastOSError; 
end;

function TShellLink.GetPath: WideString;
var
	ResultPath: Array[0..MAX_PATH] of WideChar;
	Dta: TWIN32FINDDATAW;
begin
	FShellLink.GetPath(ResultPath, MAX_PATH, Dta, SLGP_UNCPRIORITY);
	Result := ResultPath;
end;

function TShellLink.GetWorkingDirectory: WideString;
var
	ResultPath: Array[0..MAX_PATH] of WideChar;
begin
	FShellLink.GetWorkingDirectory(ResultPath, MAX_PATH);
	Result := ResultPath;
end;

constructor TShellLink.Initialize;
begin
	if CoCreateInstance(CLSID_SHELLLINK, nil, CLSCTX_INPROC_SERVER, IShellLinkW, FShellLink) <> S_OK then
		RaiseLastOSError
end;

procedure TShellLink.LoadFromFile(const FileName: WideString);
begin
	if (FShellLink as IPersistFile).Load(PWideChar(FileName), STGM_READ) <> S_OK then
		raise EInOutError.Create(SFileNotFound);
end;

function TShellLink.Resolve(Wnd: HWND): Boolean;
begin
	Result:= FShellLink.Resolve(Wnd, SLR_ANY_MATCH) = NOERROR;
end;

procedure TShellLink.SaveToFile(const FileName: WideString);
begin
	if (FShellLink as IPersistFile).Save(PWideChar(FileName), True) <> S_OK then
		raise EInOutError.Create(SAccessDenied);
end;

procedure TShellLink.SetArguments(const Value: WideString);
begin
	FShellLink.SetArguments(PWideChar(Value));
end;

procedure TShellLink.SetDescription(const Value: WideString);
begin
	FShellLink.SetDescription(PWideChar(Value));
end;

procedure TShellLink.SetPath(const Value: WideString);
begin
	FShellLink.SetPath(PWideChar(Value));
end;

procedure TShellLink.SetWorkingDirectory(const Value: WideString);
begin
	FShellLink.SetWorkingDirectory(PWideChar(Value));
end;

{ TCustomDataObject }

function TCustomDataObject.DAdvise(
				const formatetc: TFormatEtc; advf: Integer; const advSink: IAdviseSink;
				out dwConnection: Integer): HResult;
begin
	Result := OLE_E_ADVISENOTSUPPORTED;
end;

function TCustomDataObject.DUnadvise(dwConnection: Integer): HResult;
begin
	Result := OLE_E_ADVISENOTSUPPORTED;
end;

function TCustomDataObject.
				EnumDAdvise(out enumAdvise: IEnumStatData): HResult;
begin
	Result := OLE_E_ADVISENOTSUPPORTED;
end;

function TCustomDataObject.EnumFormatEtc(dwDirection: Integer;
				out enumFormatEtc: IEnumFormatEtc): HResult;
begin
	Result := E_NOTIMPL
end;

function TCustomDataObject.GetCanonicalFormatEtc(
				const formatetc: TFormatEtc;
				out formatetcOut: TFormatEtc): HResult;
begin
	Result := E_NOTIMPL
end;

function TCustomDataObject.GetData(const formatetcIn: TFormatEtc;
				out medium: TStgMedium): HResult;
begin
	Result := E_NOTIMPL
end;

function TCustomDataObject.GetDataHere(const formatetc: TFormatEtc;
				out medium: TStgMedium): HResult;
begin
	Result := E_NOTIMPL
end;

function TCustomDataObject.
				QueryGetData(const formatetc: TFormatEtc): HResult;
begin
	Result := E_NOTIMPL
end;

function TCustomDataObject.SetData(const formatetc: TFormatEtc;
				var medium: TStgMedium; fRelease: BOOL): HResult;
begin
	Result := E_NOTIMPL
end;

{ TDataObject }

function TDataObject.CompareFormat(const F1, F2: TFormatEtc): Boolean;
begin
	Result := (F1.cfFormat = F2.cfFormat) and
//					(F1.ptd      = F2.ptd)      and {ptd ͊O}
						(F1.dwAspect = F2.dwAspect) and
//					(F1.lindex   = F2.lindex)   and {lindex ͊O?}
						((F1.tymed = -1) or (F1.tymed = F2.tymed))
end;

destructor TDataObject.Destroy;
var
	I: Cardinal;
begin
	if FCount <> 0 then
	begin
		for I := 0 to Integer(FCount) - 1 do
			ReleaseStgMedium(FMediums^[I]);

		FreeMem(FFormats);
		FreeMem(FMediums);
	end;

	inherited;
end;

function TDataObject.EnumFormatEtc(dwDirection: Integer;
				out enumFormatEtc: IEnumFormatEtc): HResult;
begin
	if dwDirection <> DATADIR_GET then
	begin
		enumFormatEtc := nil;
		Result := OLE_S_USEREG
	end
	else
	begin
		//enumFormatEtc := TEnumFormatETC.Create(Self);
		Result := CreateFormatEnumerator(FCount, FFormats[0], enumFormatEtc);
	end
end;

function TDataObject.GetCanonicalFormatEtc(const formatetc: TFormatEtc;
				out formatetcOut: TFormatEtc): HResult;
begin
	formatetcOut := formatetc;
	formatetcOut.ptd := nil;
	Result := DATA_S_SAMEFORMATETC;
end;

function TDataObject.GetData(const formatetcIn: TFormatEtc;
				out medium: TStgMedium): HResult;
var
	I: Integer;
begin
	for I := FCount - 1 downto 0 do
		if CompareFormat(formatetcIn, FFormats^[I]) then
		begin
			medium := FMediums^[I];

			medium.hGlobal := OleDuplicateData(
							medium.hGlobal, FormatEtcIn.cfFormat, 0);

			Result := S_OK;
			Exit;
		end;

	Result := DV_E_FORMATETC
end;

function TDataObject.GetDataHere(const formatetc: TFormatEtc;
				out medium: TStgMedium): HResult;
var
	I: Integer;
begin
	for I := 0 to FCount - 1 do
		if CompareFormat(formatetc, FFormats^[I]) then
		begin
			medium := FMediums^[I];

			Result := S_OK;
			Exit;
		end;

	Result := DV_E_FORMATETC
end;

function TDataObject.QueryGetData(const formatetc: TFormatEtc): HResult;
var
	I: Integer;
begin
	for I := 0 to FCount - 1 do
		if CompareFormat(formatetc, FFormats^[I]) then
		begin
			Result := S_OK;
			Exit;
		end;

	Result := DV_E_FORMATETC {K}
end;

function TDataObject.SetData(const formatetc: TFormatEtc;
				var medium: TStgMedium; fRelease: BOOL): HResult;
var
	P, I: Integer;
begin
	P := FCount;
	for I := FCount - 1 downto 0 do
		if CompareFormat(formatetc, FFormats^[I]) then
		begin
			ReleaseStgMedium(FMediums^[I]);
			P := I;
			Break;
		end;

	if P >= FCount then
	begin
		Inc(FCount);
		ReallocMem(FFormats, SizeOf(FORMATETC) * FCount);
		ReallocMem(FMediums, SizeOf(STGMEDIUM) * FCount);
	end;

	FFormats^[P] := formatetc;
	FMediums^[P] := medium;

	if not fRelease then
		FMediums^[P].hGlobal :=
						OleDuplicateData(medium.hGlobal, formatetc.cfFormat, 0);

	Result := S_OK;
end;

(*
{ TEnumFormatETC }

function TEnumFormatETC.Clone(out Enum: IEnumFormatEtc): HResult;
var
	E: TEnumFormatETC;
begin
	E := TEnumFormatETC.Create(FDataObject);
	E.FIndex := FIndex;
	Enum := E;
	Result := S_OK
end;

constructor TEnumFormatETC.Create(DataObject: TDataObject);
begin
	inherited Create;
	FDataObject := DataObject
end;

function TEnumFormatETC.Next(celt: Integer; out elt; pceltFetched: PLongint): HResult;
var
	cReturn: Integer;
	e: PFORMATETC;
begin
	if (celt <= 0) or (@elt = nil) or (FIndex >= FDataObject.FCount) or
		((pceltFetched = nil) and (celt <> 1)) then
	begin
		Result := S_FALSE;
		Exit;
	end;

	cReturn := 0;
	e := @elt;

	while (FIndex < FDataObject.FCount) and (celt > 0) do
	begin
	 e^ := FDataObject.FFormats[FIndex];
	 Inc(e);
	 Inc(cReturn);
	 Dec(celt);
	end;

	if pceltFetched <> nil then
		pceltFetched^ := cReturn - celt;

	Result := S_OK;
end;

function TEnumFormatETC.Reset: HResult;
begin
	FIndex := 0;
	Result := S_OK
end;

function TEnumFormatETC.Skip(celt: Integer): HResult;
begin
	if FIndex + Cardinal(celt) >= FDataObject.FCount then
		Result := S_FALSE
	else
	begin
		Inc(FIndex, celt);
		Result := S_OK
	end
end;
*)

end.

